# VDC Entrypoint

VDC.sh is the entrypoint script to run a vdc cloud orchestration

## Introduction

Despite creating ansible roles cloud operations fail because of configuration management. That your roles
work depend of several compoents:

- The roles themselves, been properly written
- The ansible version on the controller host
- The versions of the required plugins installed on the controller host
- The Python interpreter installed in the controller host
- The version of cloud software installed on target host
- The OS installed on target host
- The Python interpreter installed in the target host
- The Python Plugins installed inthe target host

vdc is a collection of ansible roles + ansible release packaged as a docker image, that comes 
out of a Continous Integration system. The ansible roles are tested against an ansible release and
a cloud infrastructure version (OpenStack or OpenNebula). The get as close as possible to ensuring 
that they will always work as expected.

an VDC image fixes all the previouls elements for the controller host, and it is run through Continious Integration
to test all the elements of the target hosts. In CI a test matrix can be created if, for example, several
target OS versions would like to be supported.

VDC.sh is an entrypoint that makes the vdc docker image easy to use.

VDC.sh will allow you to manage multiple cloud environments and also manage your vault and ssh keys as
securely as possible.

## Using VDC.sh

You are expected to require to run more than one cloud. Perhaps because you run multiple clouds for testing, development 
or production; perhaps becuse you choose to have completely isolated clouds for multiple clients, perhaps because
you are in the process of migrating from one platform to another, one major version to another, etc. 

VDC_ENV will hold the "code" of your cloud. It can be any identifier you like: cloud1, pub1, etc.

VDC_HOME will point to a directory where the inventores for all clouds are stored. For example it could be something
like ~/devops/VDC_HOME and then each cloud will have its own VDC_ENV_HOME like for example ~/devops/VDC_HOME/cloud1

You are expected to create a symlink with the VDC_ENV to VDC.sh and place it in your ~/local/bin. When VDC starts will 
use the bash parameter $0 to find out which cloud you are requesting to use.

The environment VDC_HOME is then used to workout VDC_ENV_HOME, or where your actual cloud inventory is.

## cloud1 init

Calling VDC.sh, symlinked to your actual cloud code, will initalize your environment. 

Init will do the following things:

- Will workout where your cloud inventory is, and workout several environment variables
- Will check if you want to override any variables with specifics for your cloud, such as a particular version of the vdc image, etc.
- Will create a Linux Kernel Key Session to temporarelly cache your vault key, while it is not accessible to other applications
- Will interactively ask you for your vault key and store it with a configurable timeout
- Will unlock your SSH key, which it is expected to be encrypted with the vault key
- Will create a sock file so that the vault password can be passed into the dockerized vdc
- Will create aliases to the typical docker commands so that it fills like using local ansible despite it been dockerized
- Will change the promt so that you are aware of which cloud you are sending commands to

Everytime you execute commands:

- Will ensure that everytime you post commands the vault key timeout is refresed
- Will inform if the vault key timeout has expired
- Will call the dockerized version of the command

## Other useful tools

The vault best practice pattern, as described in ansible documention, is also recommened, where one vault file is used and variables 
referenced from a normal variable tree for the environment.