#!/bin/bash

function resolve {  
  ssh ${TEST_HOST} sudo virsh domifaddr ci_${VM_PREFIX}_$1 2> /dev/null | grep ipv4 | awk '{print $4}' | cut -d/ -f1 
} 

function start {
  echo Starting $1
  ssh ${TEST_HOST} sudo virsh start ci_${VM_PREFIX}_$1 2> /dev/null || echo $1 already running 
  echo ""
}


TEST_HOST=${1:-pvz11.vtk}
VM_PREFIX=${2:-cs_ubuntu}

ssh-add ../ci/test_id_rsa

echo STARTING CLUSTER...
start manager  
start compute1
start compute2

echo CLUSTER ADDRESSING...
MANAGER_IP=$(resolve manager)
COMPUTE1_IP=$(resolve compute1)
COMPUTE2_IP=$(resolve compute2)

echo Manager running at ${MANAGER_IP}
echo Compute1 running at ${COMPUTE1_IP}
echo Compute2 running at ${COMPUTE2_IP}

ssh-keygen -R "[localhost]:9022"

authbind ssh -L 9022:${MANAGER_IP}:22 -L 9023:${COMPUTE1_IP}:22  -L 9024:${COMPUTE2_IP}:22 -L 443:${MANAGER_IP}:443 -L 80:${MANAGER_IP}:80 ${TEST_HOST}
